{{
 Space Invaders Controls Translator
 by Alessandro De Luca - 6/26/2011
 See end of file for terms of use.
}}

CON
{
Wii digital controller bits translation:
 0: R fully pressed
 1: Start                       P4 Start
 2: Home                        P6 Reset
 3: Select                      P5 Select
 4: L fully pressed
 5: Down                        P2 Down
 6: Right                       P3 Right
 7: Up                          P7 Up
 8: Left                        P0 Left
 9: ZR
10: x
11: a                           P1 Fire
12: y
13: b   'NOTE: this table is wrong!!!
14: ZL  'control pad appear to be rotated by 90
}

CON
  SCAN_INTERVAL = 2_667_000

OBJ
  wiicc : "ClassicCtrl"

{
VAR
  long ctlstack[16]

PUB start
  cognew(loop, @ctlstack)
}

PUB init
  DIRA[7..0] := 255
  OUTA[7..0] := 255
  wiicc.init(25, 24)
  DIRA[23..16] := 255

PUB loop | time, rawbtn, decbtn
  init
  time := cnt
  repeat
    waitcnt(time += SCAN_INTERVAL)
    wiicc.readClassic
    rawbtn := wiicc.buttons
    decbtn := $FF
    if     rawbtn & $0002 'Select = 2P
      decbtn &= %11101111
    elseif rawbtn & $0004 'Home = Coin
      decbtn &= %10111111
    elseif rawbtn & $0008 'Start = 1P
      decbtn &= %11011111
    elseif rawbtn & $0020 'Right = Right
      decbtn &= %11111110
    elseif rawbtn & $0040 'Up  (unused)
      decbtn &= %11111011
    elseif rawbtn & $0080 'Left = Left
      decbtn &= %11110111
    elseif rawbtn & $0100 'Down (unused)
      decbtn &= %01111111
    elseif rawbtn & $3C00 'ABXY = Fire
      decbtn &= %11111101
    OUTA[7..0]   := decbtn
    OUTA[23..16] := decbtn ' ^ $FF

{{
┌─────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┐
│                                                   TERMS OF USE: MIT License                                                 │
├─────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation   │
│files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,   │
│modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the        │
│Software is furnished to do so, subject to the following conditions:                                                         │
│                                                                                                                             │
│The above copyright notice and this permission notice shall be included in all copies or substantial portions of the         │
│Software.                                                                                                                    │
│                                                                                                                             │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE         │
│WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR        │
│COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,  │
│ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                        │
└─────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘
}}

